
*==================================================================
*
*  㭪権 ࠡ  䠩   RepoRTF ( FoxPro) :
*
*	=rtf_Open(m.fdat,m.wincode) - ⨥ 䠩 
*		(m.fdat -  䠩 , m.wincode - ᫨ .T.,
*		஢ WINDOWS)
*
*	=rtf_PutValue(m.fldname,m.fldval,m.zn1,m.zn2,m.lev) -  
*		䠩  祭 ࠬ (m.fldname - 
*		ࠬ, m.fldval - 祭 ࠬ,
*		m.zn1 - ᫮ , m.zn2 - ᫮ 
*		᫥ ⮩, m.lev - ஢)
*
*	=rtf_LineFeed() - 襭 ࠡ⪨ ப ⠫樨
*		( ࠬ 0- ஢  ॡ)
*
*	=rtf_PutRecord(m.nlev) -   ப ⠫樨 ஢
*		m.nlev    ⥪饩  ⥪饩 ⠡
*
*	=rtf_Close() - ⨥ 䠩 
*
*	=rtf_ViewReport(m.fdat,m.fpic,m.frep) - ᬮ rtf-
*		(m.fdat -  䠩 , m.fpic -  䠩
*		蠡, m.frep -  䠩 )
*
*==================================================================


*******************************************************************
*	⨥ 䠩 

FUNCTION rtf_Open

PARAMETER m.fdat, m.wincode

	PUBLIC m.rtf_idf, m.rtf_wincode
	m.rtf_idf = FCREATE(m.fdat)
	IF m.rtf_idf>0 .AND. .NOT.m.wincode
		=FPUTS(m.rtf_idf,"|DOS:")
		ENDIF
	RETURN m.rtf_idf

*******************************************************************
*	⨥ 䠩 

PROCEDURE rtf_Close

	=FCLOSE(m.rtf_idf)
	RELEASE m.rtf_idf, m.rtf_wincode

*******************************************************************
*	 祭  䠩 

FUNCTION rtf_PutValue

PARAMETERS m.rf_fldname, m.rf_fldval, m.rf_zn1, m.rf_zn2, m.rf_lev

	m.rf_fldtype = TYPE("m.rf_fldval")
	DO CASE
		CASE m.rf_fldtype=="C"
			m.rf_vtmp = m.rf_fldval
		CASE m.rf_fldtype=="D"
			m.rf_vtmp= DTOC(m.rf_fldval)
		CASE m.rf_fldtype=="N" .OR. m.rf_fldtype=="F"
			m.rf_vtmp= LTRIM(IIF(m.rf_fldval==0,'', ;
                     	STR(m.rf_fldval,;
				IIF(EMPTY(m.rf_zn1),20,m.rf_zn1), ;
				IIF(EMPTY(m.rf_zn2),0,m.rf_zn2))))
		CASE m.rf_fldtype=="L"
			m.rf_vtmp= IIF(m.rf_fldval,'true','false')
		OTHERWISE
			m.rf_vtmp= "unknown field type "+m.rf_fldtype
		ENDCASE
	m.rf_ltmp = STR(IIF(EMPTY(m.rf_lev),0,m.rf_lev),1)
	m.rf_ftmp = m.rf_ltmp=='0'
	m.rf_rtmp = FWRITE(m.rtf_idf,'|'+m.rf_ltmp+':'+ ;
		IIF(m.rf_ftmp,'','u'+m.rf_ltmp)+m.rf_fldname+':'+ ;
		IIF(EMPTY(m.rf_zn1).OR.m.rf_fldtype#"C", ;
		ALLTRIM(m.rf_vtmp),PADR(m.rf_vtmp,m.rf_zn1)))
	IF m.rf_ftmp
		RETURN rtf_LineFeed()
		ENDIF
	RETURN m.rf_rtmp

*******************************************************************
*	뢮  䠩    ⥪饩 

PROCEDURE rtf_PutRecord

PARAMETER m.rf_inpalias, m.rf_inpnlev

	IF EMPTY(m.rf_inpalias)
		m.rf_prefix = ''
	ELSE
		m.rf_oldals = ALIAS()
		SELECT (m.rf_inpalias)
		m.rf_prefix = LOWER(m.rf_inpalias)
		ENDIF
	m.rf_nlev = IIF(EMPTY(m.rf_inpnlev),0,m.rf_inpnlev)
	m.rf_nflds = AFIELDS(rtft_masflds)
	FOR m.rf_iflds=1 TO m.rf_nflds
		m.rf_curname = rtft_masflds[m.rf_iflds,1]
		m.rf_curval = EVALUATE(m.rf_curname)
		DO rtf_PutValue WITH m.rf_prefix+m.rf_curname, ;
			m.rf_curval, ;
			0, rtft_masflds[m.rf_iflds,4], m.rf_nlev
		IF TYPE('m.rf_curval')=='D'
			m.rf_curval = IIF(m.rtf_wincode, ;
                        	P_WinDate(m.rf_curval), ;
                                P_DOSDate(m.rf_curval))
			DO rtf_PutValue WITH ;
			  m.rf_prefix+m.rf_curname+'_date', ;
			  m.rf_curval,0,0,m.rf_nlev
			ENDIF
		ENDFOR
	IF .NOT.EMPTY(m.rf_inpalias)
		SELECT (m.rf_oldals)
		ENDIF

*******************************************************************
*	襭 ࠡ⪨ ப ⠫樨

FUNCTION rtf_LineFeed

	RETURN FPUTS(m.rtf_idf,'')

*******************************************************************
*	ᬮ 

PROCEDURE rtf_ViewReport

PARAMETERS m.rf_fdat, m.rf_fpic, m.rf_frep

	rf_macro = 'RUN \APPS\reportf.exe '+m.rf_fdat+ ;
		' '+m.rf_fpic+' '+m.rf_frep
	&rf_macro

*******************************************************************
*	祭  ய

FUNCTION P_DOSDate

PARAMETERS rf_dat1

	IF EMPTY(rf_dat1)
		RETURN SPACE(22)
		ENDIF
	DIMENSION rf_month[12]
	rf_month(1) ='ﭢ'
	rf_month(2) ='䥢ࠫ'
	rf_month(3) =''
	rf_month(4) ='५'
	rf_month(5) =''
	rf_month(6) =''
	rf_month(7) =''
	rf_month(8) =''
	rf_month(9) ='ᥭ'
	rf_month(10)=''
	rf_month(11)=''
	rf_month(12)=''
	rf_smonth = MONTH(rf_dat1)
	rf_smonth = IIF( rf_smonth<1.OR.rf_smonth>12,'', ;
       	rf_month[rf_smonth] )
	RETURN Tr0(STR(DAY(rf_dat1),2))+' '+ ;
		rf_smonth+' '+LTRIM(STR(YEAR(rf_dat1)))+' '

FUNCTION P_WinDate

PARAMETERS rf_dat1

        IF EMPTY(rf_dat1)
                RETURN SPACE(22)
                ENDIF
        DIMENSION rf_month[12]
        rf_month(1) =''
        rf_month(2) =''
        rf_month(3) =''
        rf_month(4) =''
        rf_month(5) =''
        rf_month(6) =''
        rf_month(7) =''
        rf_month(8) =''
        rf_month(9) =''
        rf_month(10)=''
        rf_month(11)=''
        rf_month(12)=''
        rf_smonth = MONTH(rf_dat1)
        rf_smonth = IIF( rf_smonth<1.OR.rf_smonth>12,'', ;
        rf_month[rf_smonth] )
        RETURN Tr0(STR(DAY(rf_dat1),2))+' '+ ;
                rf_smonth+' '+LTRIM(STR(YEAR(rf_dat1)))+' '

*******************************************************************
*	 ஡  '0'  ப

FUNCTION Tr0

PARAMETERS m.st

	RETURN CHRTRAN(m.st,' ','0')
