//    
//    RepoRTF http://www.vsi.ru/~apl   
//    avbsoft@kulichki.com , a_bolkunov@mail.ru 
//     http://avbsoft.kulichki.com 
//     Reportfo.cpp
// 
// RepDat.cpp: implementation of the CRepDat class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RepDat.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRepDat::CRepDat()
{

}

CRepDat::~CRepDat()
{

}
//  
BOOL CRepDat::rtf_Open(char *fname)
{
  rtf_Outerstream = fopen(fname,"w");
  return (rtf_Outerstream!=NULL);

}
//  
BOOL CRepDat::rtf_Close()
{
  return (fclose(rtf_Outerstream)==0);

}
//  .   
BOOL CRepDat::rtf_LineFeed()
{
  return (fputs("\n",rtf_Outerstream)!=EOF);

}
//    
BOOL CRepDat::rtf_Out(CString nam, CString val, int nlev)
{
  CString slev;
  slev.Format("%i",nlev);
  int rez = fputs(("|"+slev+":"+nam+":"+val),
    rtf_Outerstream);
  if (nlev==0) return rtf_LineFeed();
  return (rez!=EOF);

}
//   1123456789   1,123,456,789
CString CRepDat::GetDivNumber(CString inpst)
{
CString stret="", st;
int i=st.GetLength();
  while (i>3)
    {
    i -=3;
    stret = ","+st.Mid(i+1,3)+stret;
    st = st.Mid(1,i);
    }
  return st+stret;

}
//    .
BOOL CRepDat::rtf_Out(CString nam, double val, int zn1, int zn2, int nlev)
{
CString szn1,smax,sst;
szn1.Format("%i",zn1);
smax.Format("%i",max(0,zn2));
char st[30];
  sprintf(st,("%"+szn1+"."+
    smax+"lf"),
      val+(val<0?-1:1)*0.000000000001);
	sst.Format("%s",st);
	sst.TrimLeft();
	sst.TrimRight();
  if (zn2<0)
    return rtf_Out(nam,GetDivNumber(st),nlev);
  else
    return rtf_Out(nam,sst,nlev);

}
//     
BOOL CRepDat::rtf_Out(CString nam, long val, int nlev)
{
  char st[12];
  ltoa(val,st,10);
  CString sst;
  sst.Format("%s",st);
  sst.TrimLeft();
  sst.TrimRight();

  return rtf_Out(nam,sst,nlev);

}
//     (form="dd.mm.yyyy")
//  (form="hh:mm")


BOOL CRepDat::rtf_Out(CString nam,int selection,int nlev)
{
	SYSTEMTIME st;
	GetSystemTime(&st);
	WORD yr,mn,dy,hr,mi,sc;
	yr=st.wYear;
	mn=st.wMonth;
	dy=st.wDay;
	hr=st.wHour;
	mi=st.wMinute;
	sc=st.wSecond;
	CString sf;
	if (selection==1)
		sf.Format("%d.%d.%d",dy,mn,yr);
	else if(selection==2)
		sf.Format("%d:%d:%d",hr,mi,sc);
	return rtf_Out(nam,sf,nlev);
}
